<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004  ()
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * smileworkflow module cm2
 *
 * @author     <>
 */



    // DEFAULT initialization of a module [BEGIN]
unset($MCONF);    
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:smile_workflow/cm2/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
require_once (PATH_t3lib."class.t3lib_tcemain.php");
    // ....(But no access check here...)
    // DEFAULT initialization of a module [END] 

define(PATH_workflow_common, PATH_site.'typo3conf/ext/smile_workflow/common/');
require_once(PATH_workflow_common.'send_mail.class.php');

class tx_smileworkflow_cm2 extends t3lib_SCbase {
    /**
     * Main function of the module. Write the content to $this->content
     */
    function main()    {
        global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
        
            // Draw the header.
        $this->doc = t3lib_div::makeInstance("mediumDoc");
        $this->doc->backPath = $BACK_PATH;
        $this->doc->form='<form action="" method="POST">';

            // JavaScript
        $this->doc->JScode = '
            <script language="javascript" type="text/javascript">
                script_ended = 0;
                function jumpToUrl(URL)    {
                    document.location = URL;
                }
            </script>
        ';

        $this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
        $access = is_array($this->pageinfo) ? 1 : 0;
        if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))    {
            if ($BE_USER->user["admin"] && !$this->id)    {
                $this->pageinfo=array("title" => "[root-level]","uid"=>0,"pid"=>0);
            }

            $headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

            $this->content.=$this->doc->startPage($LANG->getLL("title"));
            $this->content.=$this->doc->header($LANG->getLL("title"));
            $this->content.=$this->doc->spacer(5);
            $this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
            $this->content.=$this->doc->divider(5);

                
            // Render content:
            $this->moduleContent();

            
            // ShortCut
            if ($BE_USER->mayMakeShortcut())    {
                $this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
            }
        }                
        $this->content.=$this->doc->spacer(10);
    }
    function printContent()    {

        $this->content.=$this->doc->endPage();
        echo $this->content;
    }
    
    function moduleContent()    {
        $this->content .= $this->doc->section($GLOBALS['LANG']->getLL('head_title'),$content,0,1);
        
        //Get online page id
		$id = t3lib_div::_GET('id');
	
	$query = 'SELECT statedel FROM tx_smileworkflow_action WHERE page = '.$id
		.' ORDER BY crdate DESC';
	$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
	if ($conx) {
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
		if ($row){
			$currentState = $row['statedel'];
		}
		else {
			$currentState = 1;
		}
	}
	else {
		$currentState = 1;
	}
        $params = t3lib_div::_POST('delete');

        if (is_array($params)){
        	//Get workflow id
        	$wid = $this->getWorkflowTSconfig($id);
        	if ($wid) {
	        	$groupList = $GLOBALS['BE_USER']->groupList;
				//Finds out the highest state for the user
				//Not empty list => non admin user
				if ($groupList){
				$liste = $this->getWorkflowGroup($groupList);
					$stateMax = $this->findStateMax($groupList,$wid,$currentState);
					if (!(t3lib_div::inList($liste.',1',$currentState))){
						$this->content .= $GLOBALS['LANG']->getLL('no_page');
						return;
					}
				}
				//Empty list => admin
				else {
					$stateMax = 4;
				}
	
				//Deletes the page !
				if ($stateMax == 4){
					//Deletes page
					$tce = t3lib_div::makeInstance('t3lib_TCEmain');
					$tce->stripslashes_values = 0;
					$tce->start(array(),array());
					$tce->deletePages($id);
					
					print "delete : ".$test;
					
					//Refreshes page tree
					t3lib_BEfunc::getSetUpdateSignal('updatePageTree');
					
					$this->content .= $GLOBALS['LANG']->getLL('deleted');
				}
	        	
	        	//Inserts action in table smileworkflow_action
				$sql = 'INSERT INTO tx_smileworkflow_action (pid,tstamp,crdate,cruser_id,page,wid,state,statedel)
						VALUES (0,'.time().','.time().','.$GLOBALS['BE_USER']->user['uid'].','.$id.','.$wid.',0,'.$stateMax.')';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				
				//Recipient list for emails
				$emailList = $this->buildRecipientList($wid,$stateMax);
				
				//Send mail
				$mail = t3lib_div::makeInstance('SEND_MAIL');
				$mail->initMail(PATH_workflow_common.'template/mail.tmpl', PATH_workflow_common.'template/styles.css');
				$mail->sendMail($emailList,'delete',$id,$validParams['comment']);
        }
        }
        elseif ($id) {
        	$this->content .= $this->makeForm();
        }      
        else {
        	$this->content .= $GLOBALS['LANG']->getLL('no_page');
        }
    }
    
    
    /**
	 * Makes validation form
	 *
	 * @return	string		HTML output
	 */
    function makeForm(){
    	$content .= '<form name="delete" action="" method="POST">'
        		.$GLOBALS['LANG']->getLL('text').'<br><br>
		        <input type="submit" name="delete[submit]" value="'.$GLOBALS['LANG']->getLL('submit').'">
		        </form>';
        return $content;
    }
    
    
    
    /**
     * Finds the highest authorized state for the user
     *
     * @param       string          $groupList: list of the groups of the user
     * @param       int             $wid: id of workflow
     * @return      int             highest state
     */
    function findStateMax($groupList,$wid,$currentState){
        $stateList = '';

        //Selects the destgroups for each state
        $sql = 'SELECT state,destgroups FROM tx_smileworkflow_step
                                WHERE wid='.$wid.t3lib_BEfunc::deleteClause('tx_smileworkflow_step').
                                ' ORDER BY state DESC';

        $conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
        while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
                $exploded = explode(',',$row['destgroups']);
                //Finds the highest state authorized
                foreach ($exploded as $value){
                        if (t3lib_div::inList($groupList,$value) && ($row['state']+1 > $currentState)){
                                $stateList .= ','.$row['state'];
                        }
                }
        }
        //Removing the first comma
        $stateList = substr($stateList,1);
        $stateArray = explode(',',$stateList);
        //Getting a sorted array
        sort($stateArray);
        $length = count($stateArray);

        $i = 0;
        //If states allowed follow each other, we can take the highest one.
        //But if the user is a contributor/publisher, we cant bypass the state 'proposed to validation'
        while ($i<$length-1 && ($stateArray[$i+1] == ($stateArray[$i]+1))){
                $i++;
        }
        return $stateArray[$i]+1;
    }

    
    
    
    /**
	 * Builds recipient list
	 *
	 * @param	int		$wid: id of workflow
	 * @param	int		$stateMax: highest state authorized for the user
	 * @return	string		recipient list
	 */
    function buildRecipientList($wid,$stateMax){
    	//Recipient list
    	$emailList = '';
    	
    	//Finds the destination groups
    	$sql = 'SELECT destgroups FROM tx_smileworkflow_step
						WHERE wid='.$wid.' AND state='.$stateMax.' AND deleted=0 AND hidden=0';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
		
		//On regarde tous les utilisateurs non admins...pas terrible, mais comment faire mieux ?
		$query = 'SELECT email,usergroup FROM be_users WHERE admin=0';
		$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
		while ($rowQuery = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
			$explode = explode(',',$rowQuery['usergroup']);
			foreach ($explode as $value){
				//Si l'utilisateur fait partie d'un des groupes destinataires et
				//que son email est rempli, on l'ajoute  la liste
				if (t3lib_div::inList($row['destgroups'],$value) && $rowQuery['email']){
					$emailList .= ','.$rowQuery['email'];
				}
			}
		}
		//All duplicates are removed
		$emailList = substr($emailList,1);
		$emailList = t3lib_div::uniqueList($emailList);
		return $emailList;
    }
    

    
    
    /**
	 * Retrouve l'id du workflow dans le TSconfig de la page
	 *
	 * @param	int		$uid: identifiant de page
	 * @return	int		identifiant de workflow
	 */
    function getWorkflowTSconfig($uid){
    	//Get TSconfig
		$row = t3lib_BEfunc::getPagesTSconfig($uid);
		$TSvalues = t3lib_BEfunc::implodeTSParams($row);
    	//Get workflow id
		return $TSvalues['user.workflow'];
    }

	function getWorkflowGroup($group){
		$workflowGroups = '';
		$query = 'SELECT state FROM tx_smileworkflow_step WHERE destgroups IN('.$group.')';
		$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($conx) {
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
				$workflowGroups .= ','.$row['state'];
			}
			$workflowGroups = substr($workflowGroups,1);
		}
		return $workflowGroups;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/smile_workflow/cm2/index.php"])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/smile_workflow/cm2/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_smileworkflow_cm2");
$SOBE->init();


$SOBE->main();
$SOBE->printContent();

?>
