<?php
	// +----------------------------------------------------------------------+
	// | @copyright                                                           |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'db_database.class.php' ;
	require_once 'object.class.php' ;
	
	class DB_OBJECT extends OBJECT
	{
		/**
		 * object name
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_name ;
		
		/**
		 * database
		 * @var DB_DATABASE
		 * @access protected
		 **/
		
		var $m_o_database ;
	
		/**
		 * constructor
		 * @access public
		 **/

		function DB_OBJECT()
		{
			OBJECT::OBJECT() ;
		}
		
		/**
		 * get acessor for variable m_s_name
		 * @return string
		 * @access public
		 **/
		
		function get_name()
		{
			return $this->m_s_name ;
		}
		
		/**
		 * set acessor for variable m_s_name
		 * @param string $s_name
		 * @access public
		 **/
		
		function set_name($s_name)
		{
			if (is_string($s_name))
			{
				$this->m_s_name = $s_name ;
			}
		}
		
		/**
		 * get acessor for property m_o_database
		 * @return string
		 * @access public
		 **/
		
		function get_database()
		{
			return $this->m_o_database ;
		}

		/**
		 * set acessor for variable m_o_database
		 * @param string $o_database
		 * @access public
		 **/
		
		function set_database($o_database)
		{
			$this->m_o_database = $o_database ;
		}
	}
?>
