<?php

	require_once 'html_input.class.php' ;

	class HTML_CHECK_BOX extends HTML_INPUT
	{
		/**
		 * checked
		 * @var boolean
		 * @access protected
		 **/
		
		var $m_b_checked ;
		
		/**
		 * text
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_text ;
	
		/**
		 * constructor
		 * @access public
		 **/

		function HTML_CHECK_BOX()
		{
			HTML_INPUT::HTML_INPUT() ;
			
			$this->set_checked(false);
			$this->set_type('checkbox');
		}

		/**
		 * get acessor for variable m_b_checked
		 * @return boolean
		 * @access public
		 **/

		function get_checked()
		{
			return $this->m_b_checked ;
		}

		/**
		 * set acessor for variable m_b_checked
		 * @param boolean $b_checked
		 * @access public
		 **/

		function set_checked($b_checked)
		{
			if (is_bool($b_checked))
				$this->m_b_checked = $b_checked ;
		}
		
		/**
		 * get acessor for variable m_s_text
		 * @return string
		 * @access public
		 **/

		function get_text()
		{
			return $this->m_s_text ;
		}

		/**
		 * set acessor for variable m_s_text
		 * @param string $s_text
		 * @access public
		 **/

		function set_text($s_text)
		{
			if (is_string($s_text))
				$this->m_s_text = $s_text ;
		}
		
		function process()
		{
			return true ;
		}
		
		/**
		 * generate
		 * @return string
		 * @access public
		 **/

		function generate()
		{
			$s_html =	'<input ' . $this->generate_attribute() ;
			$s_html .=	($this->get_checked()) ? ' checked' : '' ;
			$s_html .=	'>&nbsp;' ;
			$s_html .=	$this->get_text() ;
			
			return $s_html ;
		}
	}
?>