<?php
	// +----------------------------------------------------------------------+
	// | @copyright                                                           |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'object.class.php' ;

	class HTML_EMAIL extends OBJECT
	{
		/**
		 * email adress
		 * @var string
		 * @access protected
		 **/

		protected $m_s_adress ;

		/**
		 * constructor
		 * @access public
		 **/

		public function __construct()
		{
			parent::__construct() ;
		}

		/**
		 * destructor
		 * @access public
		 **/

		public function __destruct()
		{
			parent::__destruct() ;
		}

		/**
		 * get accessor for variable m_s_adress
		 * @return string
		 * @access public
		 **/

		public function get_adress()
		{
			return $this->m_s_adress ;
		}

		/**
		 * set accessor for variable m_s_adress
		 * @param string $s_adress
		 * @access public
		 **/

		public function set_adress($s_adress)
		{
			if (is_string($s_adress))
				$this->m_s_adress = $s_adress ;
		}
		
		/**
		 * check email
		 * @access public
		 **/
		
		public function check()
		{
			$b_check = eregi("^[[:alpha:]]{1}[[:alnum:]]*((\.|_|-)[[:alnum:]]+)*@".
                  "[[:alpha:]]{1}[[:alnum:]]*((\.|-)[[:alnum:]]+)*".
                  "(\.[[:alpha:]]{2,})$", $this->m_s_adress
                  );
		
			/*
		
			if ($b_check)
			{
			 	list($s_login, $s_dns) = split('@', $this->m_s_adress) ;
				
				$b_check = checkdnsrr($s_dns, 'MX') ;
			}
			
			*/
			
			
			return $b_check ;
		}
		
		public function send()
		{
		
		}
	}
?>