<?php
if (!defined ("TYPO3_MODE")) 	die ("Access denied.");

if (TYPO3_MODE=="BE")	{
		
	t3lib_extMgm::addModule("tools","txsmileworkflowM1","",t3lib_extMgm::extPath($_EXTKEY)."mod1/");
}


if (TYPO3_MODE=="BE")	{
		
	t3lib_extMgm::addModule("web","txsmileworkflowM2","",t3lib_extMgm::extPath($_EXTKEY)."mod2/");
}

if (TYPO3_MODE=="BE")    {
    $GLOBALS["TBE_MODULES_EXT"]["xMOD_alt_clickmenu"]["extendCMclasses"][]=array(
        "name" => "tx_smileworkflow_cm1",
        "path" => t3lib_extMgm::extPath($_EXTKEY)."class.tx_smileworkflow_cm1.php"
    );
}


if (TYPO3_MODE=="BE")    {
    $GLOBALS["TBE_MODULES_EXT"]["xMOD_alt_clickmenu"]["extendCMclasses"][]=array(
        "name" => "tx_smileworkflow_cm2",
        "path" => t3lib_extMgm::extPath($_EXTKEY)."class.tx_smileworkflow_cm2.php"
    );
}


$tempColumns = Array (
    "tx_smileworkflow_wrole" => Array (        
        "exclude" => 1,        
        "label" => "LLL:EXT:smile_workflow/locallang_db.php:be_groups.tx_smileworkflow_wrole",        
        "config" => Array (
            "type" => "select",    
            "foreign_table" => "tx_smileworkflow_state",    
            "foreign_table_where" => "ORDER BY tx_smileworkflow_state.uid",    
            "size" => 3,    
            "minitems" => 0,
            "maxitems" => 3,
        )
    ),
);


t3lib_div::loadTCA("be_groups");
t3lib_extMgm::addTCAcolumns("be_groups",$tempColumns,1);
t3lib_extMgm::addToAllTCAtypes("be_groups","tx_smileworkflow_wrole;;;;1-1-1");


$tempColumns = Array (
    "tx_smileworkflow_state" => Array (        
        "exclude" => 1,        
        "label" => "LLL:EXT:smile_workflow/locallang_db.php:pages.tx_smileworkflow_state",        
        "config" => Array (
            "type" => "select",   
            "default" => "1",   
            "foreign_table" => "tx_smileworkflow_state",    
            "foreign_table_where" => "ORDER BY tx_smileworkflow_state.uid",    
            "size" => 1,    
            "minitems" => 0,
            "maxitems" => 1,
        )
    ),
);


t3lib_div::loadTCA("pages");
t3lib_extMgm::addTCAcolumns("pages",$tempColumns,1);
t3lib_extMgm::addToAllTCAtypes("pages","tx_smileworkflow_state;;;;1-1-1");


$TCA["tx_smileworkflow_state"] = Array (
	"ctrl" => Array (
		"title" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_state",		
		"label" => "name",	
		"tstamp" => "tstamp",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"default_sortby" => "ORDER BY name",	
		"delete" => "deleted",	
		"enablecolumns" => Array (		
			"disabled" => "hidden",
		),
		"dynamicConfigFile" => t3lib_extMgm::extPath($_EXTKEY)."tca.php",
		"iconfile" => t3lib_extMgm::extRelPath($_EXTKEY)."icon_tx_smileworkflow_state.gif",
	),
	"feInterface" => Array (
		"fe_admin_fieldList" => "hidden, name, name_follow, name_prec",
	)
);

$TCA["tx_smileworkflow_name"] = Array (
	"ctrl" => Array (
		"title" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_name",		
		"label" => "name",	
		"tstamp" => "tstamp",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"default_sortby" => "ORDER BY name",	
		"delete" => "deleted",	
		"enablecolumns" => Array (		
			"disabled" => "hidden",
		),
		"dynamicConfigFile" => t3lib_extMgm::extPath($_EXTKEY)."tca.php",
		"iconfile" => t3lib_extMgm::extRelPath($_EXTKEY)."icon_tx_smileworkflow_name.gif",
	),
	"feInterface" => Array (
		"fe_admin_fieldList" => "hidden, name",
	)
);

$TCA["tx_smileworkflow_step"] = Array (
	"ctrl" => Array (
		"title" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_step",		
		"label" => "uid",	
		"tstamp" => "tstamp",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"default_sortby" => "ORDER BY wid",	
		"delete" => "deleted",	
		"enablecolumns" => Array (		
			"disabled" => "hidden",
		),
		"dynamicConfigFile" => t3lib_extMgm::extPath($_EXTKEY)."tca.php",
		"iconfile" => t3lib_extMgm::extRelPath($_EXTKEY)."icon_tx_smileworkflow_step.gif",
	),
	"feInterface" => Array (
		"fe_admin_fieldList" => "hidden, wid, state, destgroups, exceptgroups",
	)
);

$TCA["tx_smileworkflow_action"] = Array (
	"ctrl" => Array (
		"title" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action",		
		"label" => "uid",	
		"tstamp" => "tstamp",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"default_sortby" => "ORDER BY wid",	
		"delete" => "deleted",	
		"enablecolumns" => Array (		
			"disabled" => "hidden",
		),
		"dynamicConfigFile" => t3lib_extMgm::extPath($_EXTKEY)."tca.php",
		"iconfile" => t3lib_extMgm::extRelPath($_EXTKEY)."icon_tx_smileworkflow_action.gif",
	),
	"feInterface" => Array (
		"fe_admin_fieldList" => "hidden, page, wid, state, statedel, comment",
	)
);
?>