#
# Table structure for table 'be_groups'
#
CREATE TABLE be_groups (
	tx_smileworkflow_wrole blob NOT NULL,
);



#
# Table structure for table 'pages'
#
CREATE TABLE pages (
	tx_smileworkflow_state int(11) unsigned DEFAULT '1' NOT NULL,
);



#
# Table structure for table 'tx_smileworkflow_state'
#
CREATE TABLE tx_smileworkflow_state (
	uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
	pid int(11) unsigned DEFAULT '0' NOT NULL,
	tstamp int(11) unsigned DEFAULT '0' NOT NULL,
	crdate int(11) unsigned DEFAULT '0' NOT NULL,
	cruser_id int(11) unsigned DEFAULT '0' NOT NULL,
	deleted tinyint(4) unsigned DEFAULT '0' NOT NULL,
	hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
	name varchar(50) DEFAULT '' NOT NULL,
	name_follow varchar(50) DEFAULT '' NOT NULL,
	name_prec varchar(50) DEFAULT '' NOT NULL,
	
	PRIMARY KEY (uid),
	KEY parent (pid)
);



#
# Table structure for table 'tx_smileworkflow_name'
#
CREATE TABLE tx_smileworkflow_name (
	uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
	pid int(11) unsigned DEFAULT '0' NOT NULL,
	tstamp int(11) unsigned DEFAULT '0' NOT NULL,
	crdate int(11) unsigned DEFAULT '0' NOT NULL,
	cruser_id int(11) unsigned DEFAULT '0' NOT NULL,
	deleted tinyint(4) unsigned DEFAULT '0' NOT NULL,
	hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
	name varchar(50) DEFAULT '' NOT NULL,
	
	PRIMARY KEY (uid),
	KEY parent (pid)
);



#
# Table structure for table 'tx_smileworkflow_step'
#
CREATE TABLE tx_smileworkflow_step (
	uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
	pid int(11) unsigned DEFAULT '0' NOT NULL,
	tstamp int(11) unsigned DEFAULT '0' NOT NULL,
	crdate int(11) unsigned DEFAULT '0' NOT NULL,
	cruser_id int(11) unsigned DEFAULT '0' NOT NULL,
	deleted tinyint(4) unsigned DEFAULT '0' NOT NULL,
	hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
	wid int(11) unsigned DEFAULT '0' NOT NULL,
	state int(11) DEFAULT '0' NOT NULL,
	destgroups blob NOT NULL,
	exceptgroups blob NOT NULL,
	
	PRIMARY KEY (uid),
	KEY parent (pid)
);



#
# Table structure for table 'tx_smileworkflow_action'
#
CREATE TABLE tx_smileworkflow_action (
	uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
	pid int(11) unsigned DEFAULT '0' NOT NULL,
	tstamp int(11) unsigned DEFAULT '0' NOT NULL,
	crdate int(11) unsigned DEFAULT '0' NOT NULL,
	cruser_id int(11) unsigned DEFAULT '0' NOT NULL,
	deleted tinyint(4) unsigned DEFAULT '0' NOT NULL,
	hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
	page int(11) unsigned DEFAULT '0' NOT NULL,
	wid int(11) unsigned DEFAULT '0' NOT NULL,
	state int(11) DEFAULT '0' NOT NULL,
	statedel int(11) DEFAULT '0' NOT NULL,
	comment text NOT NULL,
	
	PRIMARY KEY (uid),
	KEY parent (pid)
);