<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * PAGE class
	 * 
	 * define a page
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/db_object.class.php';

	class PAGE extends DB_OBJECT
	{
		/**
		 * uid
		 * @var integer
		 **/

		var $m_i_uid ;


		/**
		 * title
		 * @var integer
		 **/

		var $m_s_title ;

		/**
		 * title
		 * @var integer
		 **/

		var $m_s_ts_config ;


		function PAGE()
		{

		}

		/**
		 * get accessor for variable m_i_uid
		 * @return integer
		 * @access public
		 **/

		function get_uid()
		{
			return $this->m_i_uid ;
		}

		/**
		 * set accessor for variable m_i_uid
		 * @param integer $i_uid
		 * @access public
		 **/

		function set_uid($i_uid)
		{
			if (is_numeric($i_uid))
				$this->m_i_uid = $i_uid ;
		}

		/**
		 * get accessor for variable m_s_title
		 * @return string
		 * @access public
		 **/

		function get_title()
		{
			return $this->m_s_title ;
		}

		/**
		 * set accessor for variable m_s_title
		 * @param string $s_title
		 * @access public
		 **/

		function set_title($s_title)
		{
			if (is_string($s_title))
				$this->m_s_title = $s_title ;
		}

		/**
		 * get accessor for variable m_s_ts_config
		 * @return string
		 * @access public
		 **/

		function get_ts_config()
		{
			return $this->m_s_ts_config ;
		}

		/**
		 * set accessor for variable m_s_ts_config
		 * @param string $s_ts_config
		 * @access public
		 **/

		function set_ts_config($s_ts_config)
		{
			if (is_string($s_ts_config))
				$this->m_s_ts_config = $s_ts_config ;
		}

		/**
		 * assign page from a workflow
		 * @param 	integer	$i_workflow_id
		 * @access	public
		 **/

		function assign_to($i_workflow_id)
		{
			/*
			$a_tsconfig = t3lib_BEfunc::getPagesTSconfig($this->m_i_uid) ;

			if (isset($i_workflow_id))
			{
			    $a_tsconfig['user.']['workflow'] = $i_workflow_id ;
			}
		
			$this->update_ts_config($this->m_i_uid, $a_tsconfig, '') ;
			*/
			
		
			$o_table = $this->m_o_database->new_table() ;

			$o_table->set_name('pages')	;

			$o_table->add_field('tsconfig', array('type' => 'BLOB')) ;

			$a_result = $o_table->select(
				array('where' => 'uid = ' . $this->m_i_uid)
			);

			$s_typoscript = 'user.workflow' ;

			if (is_array($a_result))
			{
				$a_row = array_pop($a_result);

				$i_position = strpos(strtolower($a_row['tsconfig']), $s_typoscript) ;

				if ($i_position === false)
				{
					if (strlen($a_row['tsconfig']) > 0)
					{
					     $s_typoscript = chr(10) . $s_typoscript ;
					}
				
					$s_new_typoscript = $a_row['tsconfig'] . ' ' . $s_typoscript . ' = ' . $i_workflow_id . chr(10) ;
				}
				else
				{				
					$s_new_typoscript = substr($a_row['tsconfig'], 0, $i_position) . chr(10) . $s_typoscript . ' = ' . $i_workflow_id ;
				}
				
				$o_table->set_field('tsconfig', $s_new_typoscript) ;

				return $o_table->update('uid = ' . $this->m_i_uid);
			}
			
			return false ;
			
			
			//return $this->update_ts_config($i_workflow_id);
		}
		
		/*
		
		function update_ts_config($i_workflow_id)
		{
			$a_tsconfig = t3lib_BEfunc::getPagesTSconfig($this->m_i_uid) ;

			if (isset($i_workflow_id))
			{
			    $a_tsconfig['user.']['workflow'] = $i_workflow_id ;
			}
			else
			{
				if (isset($a_tsconfig['user.']['workflow']))
				{
					unset($a_tsconfig['user.']['workflow']) ;
				}
			}
			
			print_r($a_tsconfig) ;
			
			echo implode(chr(10), $a_tsconfig) ;
			
			echo serialize($a_tsconfig);
			
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('pages')	;

			$o_table->add_field('tsconfig', array('type' => 'BLOB')) ;
			
			$o_table->set_field('tsconfig', implode(chr(10), $a_tsconfig)) ;
			
			return $o_table->update('uid = ' . $this->m_i_uid);
		}
		
		*/
		
		/*
		
		function update_ts_config($id,$pageTS,$TSconfPrefix,$impParams='')
		{
			debug($pageTS, "pageTS") ;
		
			$id=intval($id);
		if (is_array($pageTS) && $id>0)	{
			if (!is_array($impParams))	{
				$impParams =t3lib_BEfunc::implodeTSParams(t3lib_BEfunc::getPagesTSconfig($id));
			}
			reset($pageTS);
			$set=array();
			while(list($f,$v)=each($pageTS))	{
				$f = $TSconfPrefix.$f;
				if ((!isset($impParams[$f])&&trim($v)) || strcmp(trim($impParams[$f]),trim($v)))	{
					$set[$f]=trim($v);
				}
			}
			
			if (count($set))	{
					// Get page record and TS config lines
				$pRec = t3lib_befunc::getRecord('pages',$id);
				$TSlines = explode(chr(10),$pRec['TSconfig']);
				$TSlines = array_reverse($TSlines);
					// Reset the set of changes.
				reset($set);
				while(list($f,$v)=each($set))	{
					reset($TSlines);
					$inserted=0;
					while(list($ki,$kv)=each($TSlines))	{
						if (substr($kv,0,strlen($f)+1)==$f.'=')	{
							$TSlines[$ki]=$f.'='.$v;
							$inserted=1;
							break;
						}
					}
					if (!$inserted)	{
						$TSlines = array_reverse($TSlines);
						$TSlines[]=$f.'='.$v;
						$TSlines = array_reverse($TSlines);
					}
				}
				$TSlines = array_reverse($TSlines);
				
					// store those changes
				$TSconf = implode(chr(10),$TSlines);

				$GLOBALS['TYPO3_DB']->exec_UPDATEquery('pages', 'uid='.intval($id), array('TSconfig' => $TSconf));
			}
		}
		}

		*/ 
		
		/**
		 * remove page from a workflow
		 * @param 	integer	$i_workflow_id
		 * @access	public
		 **/

		function remove_from()
		{		
			/*
				
			$a_tsconfig = t3lib_BEfunc::getPagesTSconfig($this->m_i_uid) ;
			
			if (isset($a_tsconfig['user.']['workflow']))
			{
				unset($a_tsconfig['user.']['workflow']) ;
			}

			t3lib_BEfunc::updatePagesTSconfig($this->m_i_uid, $a_tsconfig, '') ;
			
			*/
			
			
			
			$o_table = $this->m_o_database->new_table() ;

			$o_table->set_name('pages')	;

			$o_table->add_field('tsconfig', array('type' => 'BLOB')) ;

			$a_result = $o_table->select(
				array('where' => 'uid = ' . $this->m_i_uid)
			);

			$s_typoscript = 'user.workflow' ;

			if (is_array($a_result))
			{
				$a_row = array_pop($a_result) ;

				$i_position = strpos(strtolower($a_row['tsconfig']), $s_typoscript) ;

				if ($i_position === false)
				{
					return true ;
				}
				else
				{
					$s_new_typoscript = substr($a_row['tsconfig'], 0, $i_position) ;

					$o_table->set_field('tsconfig', $s_new_typoscript) ;
					
					return $o_table->update('uid = ' . $this->m_i_uid);
				}
			}

			return false ;
			
		}

		function get_workflow()
		{
			$a_tsconfig = t3lib_BEfunc::getPagesTSconfig($this->m_i_uid) ;

			if (isset($a_tsconfig['user.']['workflow']))
			{
			    $o_workflow = new WORKFLOW();

				$o_workflow->set_uid($a_tsconfig['user.']['workflow']) ;

				$o_workflow->set_database($this->m_o_database) ;

				if ($o_workflow->load())
				{
				    $s_workflow = $o_workflow->get_name() ;
				}
			}

			return $s_workflow ;
		}
	}
?>