<?php
	
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * state class
	 * 
	 * define a state
	 **/
	 
	require_once PATH_typo3conf . 'ext/smile_workflow/common/db_object.class.php';
	
	class STATE extends DB_OBJECT
	{	
		/**
		 * uid
		 * @var integer
		 **/
	
		var $m_i_uid ;
		
		/**
		 * name
		 * @var string
		 **/
		
		var $m_s_name ;
		
		/**
		 * name
		 * @var string
		 **/
		
		var $m_s_prec_name ;
		
		/**
		 * name
		 * @var string
		 **/
		
		var $m_s_follow_name ;
		
		
		function STATE()
		{		
		}
		
		/**
		 * get accessor for variable m_i_uid
		 * @return integer
		 * @access public
		 **/

		function get_uid()
		{
			return $this->m_i_uid ;
		}

		/**
		 * set accessor for variable m_i_uid
		 * @param integer $i_uid
		 * @access public
		 **/

		function set_uid($i_uid)
		{
			if (is_numeric($i_uid))
				$this->m_i_uid = $i_uid ;
		}
		
		/**
		 * get accessor for variable m_s_name
		 * @return string
		 * @access public
		 **/

		function get_name()
		{
			return $this->m_s_name ;
		}

		/**
		 * set accessor for variable m_s_name
		 * @param string $s_name
		 * @access public
		 **/

		function set_name($s_name)
		{
			if (is_string($s_name))
				$this->m_s_name = $s_name ;
		}
		
		/**
		 * get accessor for variable m_s_prec_name
		 * @return string
		 * @access public
		 **/

		function get_prec_name()
		{
			return $this->m_s_prec_name ;
		}

		/**
		 * set accessor for variable m_s_prec_name
		 * @param string $s_prec_name
		 * @access public
		 **/

		function set_prec_name($s_prec_name)
		{
			if (is_string($s_prec_name))
				$this->m_s_prec_name = $s_prec_name ;
		}
		
		/**
		 * get accessor for variable m_s_follow_name
		 * @return string
		 * @access public
		 **/

		function get_follow_name()
		{
			return $this->m_s_follow_name ;
		}

		/**
		 * set accessor for variable m_s_follow_name
		 * @param string $s_follow_name
		 * @access public
		 **/

		function set_follow_name($s_follow_name)
		{
			if (is_string($s_follow_name))
				$this->m_s_follow_name = $s_follow_name ;
		}
		
				
		function load()
		{
			$o_table = $this->m_o_database->new_table() ;
		
			$o_table->set_name('tx_smileworkflow_state') ;
			
			$a_result = $o_table->select(
				array(
					'where' => 'uid = ' . $this->m_i_uid
				)
			);

			if (is_array($a_result))
			{
				$this->m_i_uid = $a_result[0]['uid'] ;
				$this->m_i_wid = $a_result[0]['wid'] ;
				$this->m_s_name = $a_result[0]['name'] ;
				$this->m_s_prec_name = $a_result[0]['prec_name'] ;
				$this->m_s_follow_name = $a_result[0]['follow_name'] ;  
				
				return true ;
			}
			else
			{
				return false ;
			}
		}
	}
?>