<?php

	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * update a workflow
	 * 
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	 
	require_once 'workflow.class.php' ;
	
	$s_content = '<h3>' . $LANG->getLL("update_workflow") . '</h3>' ;
	
	$o_database = new DB_DATABASE_MYSQL() ;
	
	$o_database->set_connection($GLOBALS['TYPO3_DB']->link);
				
	if (!$o_database->connect())
		die() ;
	
	$o_form = new HTML_FORM() ;
					
	$o_form->set_method('post');
	$o_form->set_action(t3lib_div::getIndpEnv('REQUEST_URI'));
			
	$o_form->set_text_width(100);
	$o_form->set_field_width(200);
	$o_form->set_field_even_style('padding:4px');
	
	unset($_SESSION['workflow']);
	
	$o_workflow = new WORKFLOW() ;
	
	$o_workflow->set_database($o_database);
	
	$o_workflow->set_uid($_GET['wid']) ;
	
	$o_workflow->load() ;
				
	$o_field = $o_form->new_field($LANG->getLL("name"));
					
	$o_input = $o_field->add_input('workflow_name', 'text', $o_workflow->get_name()) ;
				
	$o_field->set_html_object($o_input) ;
				
	$o_form->add_field($o_field);
					
	$o_form->add_button('action_next', $LANG->getLL("action_next")) ;
				
	if ($o_form->process())
	{
		$o_workflow->set_name($_POST['workflow_name']);
					
		if ($o_workflow->update())
		{
			$o_workflow->load_page(true);
			
			if (count($o_workflow->get_page()) > 0)
			{
			 	header('Location:' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=list_workflow');
				
				exit() ;
			}
			else
			{
				$o_workflow->load_step() ;
			
				$_SESSION['workflow'] = serialize($o_workflow) ;
			
		    	header('Location:' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=update_step');
						
				exit() ;
			}
		}	
	}
	else
	{
		$s_content .= '<p>' . $o_form->get_message() . '</p>' ;
	}
	
	$o_database->disconnect() ;

	$s_content .= $o_form->generate() ;

?>