<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * view workflow
	 * 
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	 
	require_once 'workflow.class.php' ;
	require_once 'html_list_step.class.php' ;
	
	$o_database = new DB_DATABASE_MYSQL() ;
	
	$o_database->set_connection($GLOBALS['TYPO3_DB']->link);
				
	if (!$o_database->connect())
		die() ;
	
	$o_workflow = new WORKFLOW() ;
	
	$o_workflow->set_database($o_database);
	
	$o_workflow->set_uid($_GET['wid']) ;
	
	$o_workflow->load() ;
	$o_workflow->load_page(true) ;
	$o_workflow->load_step() ;
	
	$o_html_list_step = new HTML_LIST_STEP() ;
	
	$o_html_list_step->set_database($o_database);
	$o_html_list_step->set_workflow($o_workflow) ;
	
	$o_html_list_step->create(false) ;
	
	$s_content .= '<h3>' . $LANG->getLL("workflow_information") . ' ' . $o_workflow->get_name() . '</h3>' ;
	
	$s_content .= '<h3>' . $LANG->getLL("workflow_step_list") . '</h3>' ;
	
	$s_content .= $o_html_list_step->generate() ;
	
	$s_content .= '<h3>' . $LANG->getLL("workflow_page_list") . '</h3>' ;

	$o_page_list = new HTML_LIST() ;
	
	$o_page_list->create_row() ;
				
	$o_page_list->add_cell('&nbsp;', 30, 20, 1,'bgColor5') ;
	$o_page_list->add_cell('<b>Uid</b>', 50, 20, 1,'bgColor5') ;
	$o_page_list->add_cell('<b>' . $LANG->getLL("name") . '</b>', 220, 20, 1,'bgColor5') ;
	$o_page_list->add_cell('<b>Workflow</b>', 150, 20, 1,'bgColor5') ;
					
	$o_page_list->add_row() ;
	
	$a_page = $o_workflow->get_page() ;
	
	foreach($a_page as $o_page)
	{
		$o_page_list->create_row() ;
				
		$o_page_list->add_cell('&nbsp;', 30, 20, 1, 'bgColor4') ;

				
		$o_page_list->add_cell($o_page->get_uid(), 50, 20, 1, 'bgColor4', 'padding-left:4px;');
		$o_page_list->add_cell($o_page->get_title(), 220, 20, 1, 'bgColor4', 'padding-left:4px;');
		$o_page_list->add_cell($o_page->get_workflow(), 150, 20, 1, 'bgColor4', 'padding-left:4px;');
					
		$o_page_list->add_row() ;
	}
	
	$s_content .= $o_page_list->generate() ;
	
	$s_content .= '<br><a href="?page=list_workflow">'. $LANG->getLL('action_finish') .'</a>' ;
	
	$o_database->disconnect() ;
	
?>