<?php

	require_once 'html_object.class.php';

	class HTML_NAVIGATION extends OBJECT
	{
		/**
		 * width
		 * @var integer
		 * @access protected
		 **/
	
		var $m_i_width ;
		
		/**
		 * width
		 * @var integer
		 * @access protected
		 **/
	
		var $m_i_height ;
		
		/**
		 * class
		 * @var string
		 * @access protected
		 **/
	
		var $m_s_class ;
		
		/**
		 * style
		 * @var string
		 * @access protected
		 **/
	
		var $m_s_style ;
	
		/**
		 * start
		 * @var integer
		 * @access protected
		 **/
	
		var $m_i_start ;
	
		/**
		 * answer count
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_answer_count ;
		
		/**
		 * total answer count
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_total_answer_count ;
		
		/**
		 * max answer count / page
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_max_answer_count ;
		
		/**
		 * page count
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_page_count ;
		
		/**
		 * url
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_url ;
		
		/**
		 * message with answer
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_message_with_answer ;
		
		/**
		 * message no answer answer
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_message_no_answer ;
		
		/**
		 * start icon
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_start_link ;
		
		/**
		 * previous icon
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_previous_link ;
		
		/**
		 * next icon
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_next_link ;
		
		/**
		 * end icon
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_end_link ;
		
		/**
		 * space between icons
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_space ;
		
		/**
		 * constructor
		 * @access public
		 **/

		function HTML_NAVIGATION()
		{
			OBJECT::OBJECT() ;
		}
		
		function get_width()
		{
			return $this->m_i_width ;
		}
		
		function set_width($i_width)
		{
			if (is_numeric($i_width))
			{
				$this->m_i_width = $i_width ;
			}
		}
		
		function get_height()
		{
			return $this->m_i_height ;
		}
		
		function set_height($i_height)
		{
			if (is_numeric($i_height))
			{
				$this->m_i_height = $i_height ;
			}
		}
		
		function get_class()
		{
			return $this->m_s_class ;
		}
		
		function set_class($s_class)
		{
			if (is_string($s_class))
			{
				$this->m_s_class = $s_class ;
			}
		}
		
		function get_style()
		{
			return $this->m_s_style ;
		}
		
		function set_style($s_style)
		{
			if (is_string($s_style))
			{
				$this->m_s_style = $s_style ;
			}
		}
		
		function get_start()
		{
			return $this->m_i_start ;
		}
		
		function set_start($i_start)
		{
			$this->m_i_start = $i_start ;
		}
		
		function get_answer_count()
		{
			return $this->m_i_answer_count ;
		}
		
		function set_answer_count($i_answer_count)
		{
			$this->m_i_answer_count = $i_answer_count ;
		}
		
		function get_total_answer_count()
		{
			return $this->m_i_total_answer_count ;
		}
		
		function set_total_answer_count($i_total_answer_count)
		{
			$this->m_i_total_answer_count = $i_total_answer_count ;
		}
		
		function get_max_answer_count()
		{
			return $this->m_i_max_answer_count ;
		}
		
		function set_max_answer_count($i_max_answer_count)
		{
			$this->m_i_max_answer_count = $i_max_answer_count ;
		}
		
		function get_page_count()
		{
			return $this->m_i_page_count ;
		}
		
		function set_page_count($i_page_count)
		{
			$this->m_i_page_count = $i_page_count ;
		}
		
		function get_url()
		{
			return $this->m_s_url ;
		}
		
		function set_url($s_url)
		{
			$this->m_s_url = $s_url ;
		}
		
		function get_message_with_answer()
		{
			return $this->m_s_message_with_answer ;
		}
		
		function set_message_with_answer($s_message_with_answer)
		{
			$this->m_s_message_with_answer = $s_message_with_answer ;
		}
		
		function get_message_no_answer()
		{
			return $this->m_s_message_no_answer ;
		}
		
		function set_message_no_answer($s_message_no_answer)
		{
			$this->m_s_message_no_answer = $s_message_no_answer ;
		}
		
		function get_start_link()
		{
			return $this->m_s_start_link ;
		}
		
		function set_start_link($s_start_link)
		{
			$this->m_s_start_link = $s_start_link ;
		}
		
		function get_previous_link()
		{
			return $this->m_s_previous_link ;
		}
		
		function set_previous_link($s_previous_link)
		{
			$this->m_s_previous_link = $s_previous_link ;
		}
		
		function get_next_link()
		{
			return $this->m_s_next_link ;
		}
		
		function set_next_link($s_next_link)
		{
			$this->m_s_next_link = $s_next_link ;
		}
		
		function get_end_link()
		{
			return $this->m_s_end_link ;
		}
		
		function set_end_link($s_end_link)
		{
			$this->m_s_end_link = $s_end_link ;
		}
		
		function get_space()
		{
			return $this->m_s_space ;
		}
		
		function set_space($s_space)
		{
			$this->m_s_space = $s_space ;
		}
		
		function generate()
		{		
			if (empty($this->m_i_max_answer_count))
			{
			    $this->m_i_max_answer_count = 20 ;
			}
		
			$s_html = '<table width="' . $this->m_i_width . '" height="' . $this->m_i_height . '" border="0" cellpadding="0" cellspacing="0">';
			$s_html .= '<tr>';
			$s_html .= '<td width="' . $this->m_i_width . '" height="' . $this->m_i_height . '" align="center"';
			
			if (!empty($this->m_s_class))
				$s_html .= ' class="' . $this->m_s_class . '"';
				
			if (!empty($this->m_s_style))
				$s_html .= ' style="' . $this->m_s_style . '"';
			
			$s_html .= '><b>';
			
			if ($this->m_i_total_answer_count > 0)
			{
				$s_html .= $this->m_s_message_with_answer . " " . ($this->m_i_start+1) . " - " . ($this->m_i_start+$this->m_i_answer_count) . " / " . $this->m_i_total_answer_count . $this->m_s_space;

				if ($this->m_i_start >= $this->m_i_max_answer_count)
				{
					$cible = 0;
					
					$s_html .= '<a href="' . $this->m_s_url . '&start=' . $cible . '">' . $this->m_s_start_link .  '</a>';
				}
				else
					$s_html .= $this->m_s_start_link;
				
				$s_html .= $this->m_s_space ;

				if ($this->m_i_start >= $this->m_i_max_answer_count)
				{
					$cible = $this->m_i_start - $this->m_i_max_answer_count ;
				
					$s_html .= '<a href="' . $this->m_s_url . '&start=' . $cible . '">' . $this->m_s_previous_link . '</a>';
				}
				else
					$s_html .= $this->m_s_previous_link ;
					
				$s_html .= $this->m_s_space ;

				if ($this->m_i_start >= ($this->m_i_page_count * $this->m_i_max_answer_count))
				{
					$cpt_fin = ($this->m_i_start / $this->m_i_max_answer_count) + 1;

					$cpt_deb = $cpt_fin - $this->m_i_page_count + 1 ;
				}
				else
				{
					$cpt_deb = 1;

					$cpt_fin = (int)($this->m_i_total_answer_count / $this->m_i_max_answer_count);

					if (($this->m_i_total_answer_count % $this->m_i_max_answer_count) != 0)
						$cpt_fin++ ;

					if ($cpt_fin > $this->m_i_page_count)
						$cpt_fin = $this->m_i_page_count;
				}

				for ($cpt = $cpt_deb ; $cpt <= $cpt_fin ; $cpt++)
				{
					if ($cpt == (($this->m_i_start / $this->m_i_max_answer_count) + 1))
						$s_html .= '&nbsp;' . $cpt . '&nbsp;';
					else
					{
						$cible = ($cpt - 1) * $this->m_i_max_answer_count ;
					
						$s_html .= '&nbsp;<a href="' . $this->m_s_url . '&start=' . $cible . '" class="normal">' . $cpt . '</a>&nbsp;';
					}
				}

				$s_html .= $this->m_s_space;
				
				//-- Suivant

				if ($this->m_i_start + $this->m_i_max_answer_count < $this->m_i_total_answer_count)
				{
					$cible = $this->m_i_start + $this->m_i_max_answer_count ;
					$s_html .= '&nbsp;<a href="' . $this->m_s_url . '&start=' . $cible . '">' . $this->m_s_next_link . '</a>&nbsp;';
				}
				else
					$s_html .= $this->m_s_next_link ;

				$s_html .= $this->m_s_space;
			
				$fin = ($this->m_i_total_answer_count - ($this->m_i_total_answer_count % $this->m_i_max_answer_count)) ;

				if (($this->m_i_total_answer_count % $this->m_i_max_answer_count) == 0)
					$fin = $fin - $this->m_i_max_answer_count ;

				if ($fin != $this->m_i_start)
					$s_html .= '&nbsp;<a href="' . $this->m_s_url . '&start=' . $fin . '">' . $this->m_s_end_link . '</a>&nbsp;';
				else
					$s_html .= '&nbsp;' . $this->m_s_end_link . '&nbsp;';
			}
			else
			{
				if (empty($this->m_s_message_no_answer))
					$s_html .= '&nbsp;';
				else
					$s_html .= $this->m_s_message_no_answer ;
			}
			
			$s_html .= '</b></td>';
			$s_html .= '</tr>';
			$s_html .= '</table>';
			
			return $s_html ;
		}
	}
?>