<?php
	require_once 'html_object.class.php' ;
	require_once 'html_cell.class.php' ;
	
	class HTML_ROW extends HTML_OBJECT
	{
		var $m_a_cell ;
		
		var $m_s_row_class ;
		
		var $m_s_row_style ;
	
		function HTML_ROW()
		{
			HTML_OBJECT::HTML_OBJECT() ;
		
			$this->set_cell(array());
		}
		
		function get_cell()
		{
			return $this->m_a_cell ;
		}
		
		function get_row_class()
		{
			return $this->m_s_row_class ;
		}
		
		function get_row_style()
		{
			return $this->m_s_row_style ;
		}
		
		function set_cell($a_cell)
		{
			$this->m_a_cell = $a_cell ;
		}
		
		function set_row_class($s_row_class)
		{
			$this->m_s_row_class = $s_row_class ;
		}
		
		function set_row_style($s_row_style)
		{
			$this->m_s_row_style = $s_row_style ;
		}
		
		function add_cell($s_text='', $i_width='', $i_height='', $i_colspan='', $s_cell_class='', $s_cell_style='')
		{
			if (empty($s_cell_class))
			{
				$s_cell_class = $this->m_s_row_class ; 
				$s_cell_style = $this->m_s_row_style ; 
			}
		
			$o_cell = new HTML_CELL();
		
			if (strtolower(get_parent_class($s_text)) == 'html_object')
			{
			    $o_cell->set_object($s_text) ;
			}
			else
			{
				$o_cell->set_text($s_text);
			}
			
			$o_cell->set_width($i_width);
			$o_cell->set_height($i_height);
			$o_cell->set_colspan($i_colspan);
			$o_cell->set_class($s_cell_class);
			$o_cell->set_style($s_cell_style);
		
			array_push($this->m_a_cell, $o_cell);
		}
		
		function generate()
		{
			$s_html = '<tr>';
			
			foreach($this->m_a_cell as $o_cell)
				$s_html .= $o_cell->generate();
				
			$s_html .= '</tr>';
			
			return $s_html ;
		}
	}
?>