<?php

	require_once 'html_object.class.php';
	
	class HTML_TEXT_AREA extends HTML_OBJECT
	{
	
		/**
		 * textarea value
		 * @var string
		 * @access protected
		 **/
	
		var $m_s_value ;
	
		/**
		 * constructor
		 * @access public
		 **/
	
		function HTML_TEXT_AREA()
		{
			HTML_OBJECT::HTML_OBJECT() ;
		}
		
		/**
		 * destructor
		 * @access public
		 **/
		
		function __destruct()
		{
			parent::__destruct() ;
		
			$this->set_smiley_toolbar(false) ;
		}
		
		function get_value()
		{
			return $this->m_s_value ;
		}
		
		function set_value($s_value)
		{
			$this->m_s_value = stripslashes($s_value) ;
		}
		
		public function process()
		{
			return true ;
		}
		
		/**
		 * generate html
		 * @return string
		 * @access public
		 **/
		
		function generate()
		{
			$s_html	=	'<textarea '
					.	$this->generate_attribute()
					.	' wrap="hard">'
					.	$this->get_value()
					.	'</textarea>' ;
				
			return $s_html ;
		}
	}
?>