<?php

	if (!defined(PATH_tslib)) define('PATH_tslib', PATH_site.'tslib/');
	if (!defined(PATH_t3lib)) define('PATH_t3lib', PATH_site.'t3lib/');
	if (!defined(PATH_workflow_common)) define(PATH_workflow_common, PATH_site.'typo3conf/ext/smile_workflow/common/');

	require_once(PATH_tslib."class.tslib_content.php");	

	class SEND_MAIL
	{
	//template to design mail
	var $templateMail;

	// define the style of the mail
	var $cssfile;
	
	var $langmail;
	
	function initMail ($mailtmpl, $stylecss = ''){
		$this->templateMail = $mailtmpl;
		$this->cssfile = $stylecss;
		$this->langmail = t3lib_div::makeInstance('language');
		$this->langmail->includeLLFile("EXT:smile_workflow/common/locallangmail.php");
	}
	
	/**
	 * to do : create a form in order to see the page preview 
	 * and the admin panel directly from the mail.
	 *
	 */
	function makeFormMail() {
		$form = '<form action="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/index.php" method="get">
				<input type="hidden" name="redirect_url" value="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/sysext/cms/layout/db_layout.php?id=70">
				<input type="submit" value"voir">
			</form>
				<a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/index.php?redirect_url='.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/sysext/cms/layout/db_layout.php?id=70">test<a/>
				<br>
				<a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/index.php?redirect_url='.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/sysext/cms/layout/db_layout.php?id=70\"%20onload=\"previewWin=window.open(\'../../../../index.php?id=70\',\'newTypo3FrontendWindow\',\'status=1,menubar=1,resizable=1,location=1,scrollbars=1,toolbar=1\');previewWin.focus();">test<a/>
				<br>
				<a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/index.php?redirect_url='.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'index.php?id=70">test<a/>
			';
		return $form;
	}
	
	/**
	 * Design the mail content
	 *
	 * @param	string		$name: BE mail sender name
	 * @param	string		$texte: using text
	 * @param	string		$page: name of the changed page
	 * @param	string		$$style: .css file, put in the mail header
	 * @return	void		
	 */
	function makeBodyMail($body, $comment = '', $other = '', $style = '')
	{
		$cObj = new tslib_cObj;
		$fichier = $this->templateMail;
		$id_fichier = fopen($fichier,"r");
		if ($id_fichier){
			while (!feof($id_fichier)) {
				$template .= fread($id_fichier, filesize($fichier));//fgets($id_fichier, 4096);
			}
		}
		fclose($id_fichier);

		//Choix de la sous-partie du template prise en considration
		$zone = $cObj->getSubpart($template,"###TEMPLATE_MAIN###");			
		
		//Remplacement des marqueurs
		$markerArray = array();
		
		$markerArray["###BODY###"] = $body;
		$markerArray["###COMMENT###"] = $comment;
		$markerArray["###OTHER###"] = $other;
		
		if ($style) {
			$id_fichier = fopen($style,"r");
			if ($id_fichier){
				while (!feof($id_fichier)) {
				$css .= fread($id_fichier, filesize($style));//fgets($id_fichier, 4096);
				}
			}
			fclose($id_fichier);
			$markerArray["###STYLE###"] = $css;
		}
		$out = $cObj->substituteMarkerArray($zone,$markerArray);			
	
	// Return value
	return $out;
	}
	
	/**
	 * Sends emails
	 *
	 * @param	string		$emailList: recipient list
	 * @param	string		$type: 4 types : refuse/accept/admin/delete according on the mail send case
	 * @param	string		$text: information text about changes
	 * @param	int		$realUid: real uid of the page
	 * @param	string		$comment: comment to send
	 * @param	string		$title: if you want to specify a special title, else the title of the page in BE
	 * @return	void		
	 */
	function sendMail($emailList,$type,$realUid,$realComment,$realStatut = '',$realOther = '')
	{	
		$style = $this->cssfile;

		$sql = 'SELECT title, tx_smileworkflow_state FROM pages WHERE uid='.$realUid;
		$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
		
		$title = $row['title'];
  		
  		$staticsubject = $this->langmail->getLL('subject_'.$type);
		$staticbody = $this->langmail->getLL('body_'.$type);

		switch($type)
		{
	  		case 'refuse':
	  			$stat = $row['tx_smileworkflow_state'] + 1;
	  			break;
	  		case 'accept':
	  			$stat = $row['tx_smileworkflow_state'];
	  			break;
	  		case 'admin':
	  			$stat = $realStatut;
	  			break;
	  		case 'delete':
	  			$stat = '';
	  			$realOther = $this->langmail->getLL('information').'<br>id = '.$realUid;
	  			break;
  		}
  		$statut = $this->langmail->getLL('statut_'.$stat);

		//mail subject
		$subject = $staticsubject.$statut.' of the page \''.$title.'\'.';
		if($type == 'admin'){
			$statut2 = $this->langmail->getLL('statut_'.$row['tx_smileworkflow_state']);
			$subject = $staticsubject.'from '.$statut2.' to '.$statut.' for the page \''.$title.'\'.';
		}
		
		//mail body
		$link = '<a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'typo3/index.php?redirect_url='.urlencode(t3lib_div::getIndpEnv('TYPO3_SITE_URL').'index.php?id='.$realUid.'&ADMCMD_simUser=1').'">'.$title.'</a>';
		$body = $GLOBALS['BE_USER']->user['realName'].$staticbody.$link.'.';
		if ($realComment){
			$comment = $this->langmail->getLL('comment').$realComment;
		}
		if ($realOther){
			$other = $this->langmail->getLL('other').$realOther;
		}
		$message = $this->makeBodyMail($body, $comment, $other, $style);		
		
		//mail header
		$headers .= "MIME-Version: 1.0\n";
		$headers .= 'Content-type: text/html; charset= iso-8859-1'.chr(10);
		$headers .= 'From: '.$GLOBALS['BE_USER']->user['email'];
	
		//Envoi du mail
		@t3lib_div::plainMailEncoded($emailList,$subject,$message,$headers);
	}
	
	}
?>