<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * workflow list
	 * 
	 **/
	
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	 
	require_once 'html_list_workflow.class.php' ;
	require_once 'workflow.class.php' ;


	$s_content = '<h3>' . $LANG->getLL("list_workflow") . '</h3>' ;
	
		$o_database = new DB_DATABASE_MYSQL() ;
	
		$o_database->set_connection($GLOBALS['TYPO3_DB']->link);
				
	if (!$o_database->connect())
		die() ;
			
		    if (isset($_POST['action']))
			{
			    $action = $_POST['action'] ;
			}
			else
				if (isset($_GET['action']))
				{
				    $action = $_GET['action'] ;
				}
		
	$o_html_list_workflow = new HTML_LIST_WORKFLOW() ;
					
	$o_html_list_workflow->set_database($o_database);
					
	$o_html_list_workflow->set_limit(20);
			
	$o_html_list_workflow->load() ;
				
	$o_form = new HTML_FORM() ;
			
	$o_form->set_name('workflow_list_form') ;
	$o_form->set_method('post') ;
	$o_form->set_action(t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=list_workflow') ;
			
	$o_field = $o_form->new_field('') ;
			
	$o_field->set_text_cell(null) ;
	$o_field->set_html_object($o_html_list_workflow) ;
			
	$o_form->add_field($o_field) ;

	if (isset($_POST['action_drop_workflow']) || isset($_GET['action_drop_workflow']))
	{
	    if (isset($_GET['wid']))
		{
		    $o_workflow = new WORKFLOW() ;
				
			$o_workflow->set_uid($_GET['wid']) ;
					
			$o_workflow->set_database($o_database);
					
			if ($o_workflow->drop())
			{
				$i_start = $o_html_list_workflow->get_start() ;
					
				header('Location: index.php?page=list_workflow&start=' . $i_start);
					
				exit() ;
			}
			else
			{
				$o_workflow->load() ;
			
				$_GET['error_drop'] = urlencode($o_workflow->get_name()) ;
			}
		}
		else
			if (isset($_POST['workflow_list']))
			{
				$b_error = false ;
			
				$a_workflow = $_POST['workflow_list'] ;
				
			    foreach($a_workflow as $i_workflow)
				{
					$o_workflow = new WORKFLOW() ;
				
					$o_workflow->set_uid($i_workflow) ;
		
					$o_workflow->set_database($o_database);
							
					if (!$o_workflow->drop())
					{
					 	$b_error = true ; 
						
						$o_workflow->load() ;
						
						$_GET['error_drop'] = urlencode($o_workflow->get_name()) ;
					}
				}
							
				$i_start = $o_html_list_workflow->get_start() ;
			
				if ($b_error)
				{
				 	header('Location: index.php?page=list_workflow&error_drop='. $_GET['error_drop'] .'&start=' . $i_start);   
				}
				else
				{
					header('Location: index.php?page=list_workflow&start=' . $i_start);
				}
					
				exit() ;
			}
	}
	
	if (isset($_GET['error_drop']))
	{
	    $s_content .= '<p><b>' . sprintf($LANG->getLL("workflow_not_dropped"), urldecode($_GET['error_drop'])) . '</b></p><br>' ;
	}
		
	if (isset($_POST['action_create_workflow']))
	{
		header('Location: index.php?page=create_workflow');
				
		exit();
	}
		
	if (isset($_GET['action_update_workflow']))
	{
		unset($_SESSION['workflow']);
			
		header('Location: index.php?page=update_workflow&wid=' . $_GET['wid']);
				
		exit() ;
	}
		
	if (isset($_GET['action_assign_page']))
	{
		unset($_SESSION['workflow']);
				
		header('Location: index.php?page=assign_page&wid=' . $_GET['wid']);
		
		exit();
	}
	
	if (isset($_GET['action_view_workflow']))
	{
		unset($_SESSION['workflow']);
				
		header('Location: index.php?page=view_workflow&wid=' . $_GET['wid']);
				
		exit();
	}
		
	if (isset($_POST['action_view_page']))
	{
		unset($_SESSION['workflow']);
				
		header('Location: index.php?page=view_page');
				
		exit();
	}
	
	$s_content .= $o_form->generate() ;
		
	$o_database->disconnect() ;
?>