<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * assign pages
	 * 
	 **/

	require_once 'html_list_page.class.php' ;
	require_once 'workflow.class.php' ;
	
	$s_content = '<h3>' . $LANG->getLL("list_page") . '</h3>' ;
	
	$o_database = new DB_DATABASE_MYSQL() ;
	
	$o_database->set_connection($GLOBALS['TYPO3_DB']->link);
				
	if (!$o_database->connect())
		die() ;

	$o_html_list_page = new HTML_LIST_PAGE() ;
	
	$o_html_list_page->set_action(false) ;
	
	$o_html_list_page->set_database($o_database) ;
	
	$o_html_list_page->set_limit(20);
	
	$o_html_list_page->load() ;
	
	$o_form = new HTML_FORM() ;
			
	$o_form->set_name('page_list_form') ;
	$o_form->set_method('post') ;
	$o_form->set_action($_SERVER['SCRIPT_NAME'] . '?page=assign_page') ;
			
	$o_field = $o_form->new_field('') ;
			
	$o_field->set_text_cell(null) ;
	$o_field->set_html_object($o_html_list_page) ;
			
	$o_form->add_field($o_field) ;
	
	$s_content .= $o_form->generate() ;
	
	if (isset($_POST['action_finish']))
	{
		unset($_SESSION['workflow']);
			
		header('Location:' . $_SERVER['SCRIPT_NAME'] . '?page=list_workflow');
		
		exit();
	}
	
	$o_database->disconnect() ;

?>