<?php
if (!defined ("TYPO3_MODE")) 	die ("Access denied.");

$TCA["tx_smileworkflow_state"] = Array (
	"ctrl" => $TCA["tx_smileworkflow_state"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,name,name_follow,name_prec"
	),
	"feInterface" => $TCA["tx_smileworkflow_state"]["feInterface"],
	"columns" => Array (
		"hidden" => Array (		
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
			"config" => Array (
				"type" => "check",
				"default" => "0"
			)
		),
		"name" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_state.name",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
		"name_follow" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_name.name_follow",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"name_prec" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_name.name_prec",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "hidden;;1;;1-1-1, name, name_follow, name_prec")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);



$TCA["tx_smileworkflow_name"] = Array (
	"ctrl" => $TCA["tx_smileworkflow_name"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,name"
	),
	"feInterface" => $TCA["tx_smileworkflow_name"]["feInterface"],
	"columns" => Array (
		"hidden" => Array (		
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
			"config" => Array (
				"type" => "check",
				"default" => "0"
			)
		),
		"name" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_name.name",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "hidden;;1;;1-1-1, name")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);



$TCA["tx_smileworkflow_step"] = Array (
	"ctrl" => $TCA["tx_smileworkflow_step"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,wid,state,destgroup,exceptgroups"
	),
	"feInterface" => $TCA["tx_smileworkflow_step"]["feInterface"],
	"columns" => Array (
		"hidden" => Array (		
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
			"config" => Array (
				"type" => "check",
				"default" => "0"
			)
		),
		"wid" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_step.wid",		
			"config" => Array (
				"type" => "select",	
				"items" => Array (
					Array("",0),
				),
				"foreign_table" => "tx_smileworkflow_name",	
				"foreign_table_where" => "ORDER BY tx_smileworkflow_name.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"state" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_step.state",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_smileworkflow_state",	
				"foreign_table_where" => "ORDER BY tx_smileworkflow_state.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"destgroups" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_step.destgroups",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "be_groups",	
				"foreign_table_where" => "ORDER BY be_groups.uid",	
				"size" => 7,	
				"minitems" => 0,
				"maxitems" => 10,
			)
		),
		"exceptgroups" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_step.exceptgroups",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "be_groups",	
				"foreign_table_where" => "ORDER BY be_groups.uid",	
				"size" => 7,	
				"minitems" => 0,
				"maxitems" => 10,
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "hidden;;1;;1-1-1, wid, state, destgroups, exceptgroups")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);



$TCA["tx_smileworkflow_action"] = Array (
	"ctrl" => $TCA["tx_smileworkflow_action"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,page,wid,state,statedel,comment"
	),
	"feInterface" => $TCA["tx_smileworkflow_action"]["feInterface"],
	"columns" => Array (
		"hidden" => Array (		
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
			"config" => Array (
				"type" => "check",
				"default" => "0"
			)
		),
		"page" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action.page",		
			"config" => Array (
				"type" => "select",	
				"items" => Array (
					Array("",0),
				),
				"foreign_table" => "pages",	
				"foreign_table_where" => "ORDER BY pages.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"wid" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action.wid",		
			"config" => Array (
				"type" => "select",	
				"items" => Array (
					Array("",0),
				),
				"foreign_table" => "tx_smileworkflow_name",	
				"foreign_table_where" => "ORDER BY tx_smileworkflow_name.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"state" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action.state",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_smileworkflow_state",	
				"foreign_table_where" => "ORDER BY tx_smileworkflow_state.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"statedel" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action.statedel",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_smileworkflow_state",	
				"foreign_table_where" => "ORDER BY tx_smileworkflow_state.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"comment" => Array (		
			"exclude" => 1,        
            "label" => "LLL:EXT:smile_workflow/locallang_db.php:tx_smileworkflow_action.author_prec",        
            "config" => Array (
                "type" => "text",
                "cols" => "30",    
                "rows" => "5",
            )
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "hidden;;1;;1-1-1, wid, state, statedel, comment")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);
?>